package com.jasamedika.medifirst2000.service.impl;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.PapRencanaKonsultasiConverter;
import com.jasamedika.medifirst2000.dao.AntrianPasienDiPeriksaDao;
import com.jasamedika.medifirst2000.dao.PapRencanaKonsultasiDao;
import com.jasamedika.medifirst2000.dao.PasienDaftarDao;
import com.jasamedika.medifirst2000.entities.AntrianPasienDiPeriksa;
import com.jasamedika.medifirst2000.entities.PapRencanaKonsultasi;
import com.jasamedika.medifirst2000.enums.StatusAntrianEnum;
import com.jasamedika.medifirst2000.enums.StatusKunjunganEnum;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.AntrianPasienDiPeriksaService;
import com.jasamedika.medifirst2000.service.PapRencanaKonsultasiService;
import com.jasamedika.medifirst2000.util.CommonUtil;
import com.jasamedika.medifirst2000.vo.PapRencanaKonsultasiVO;

/**
 * Implement class for PapRencanaKonsultasiService
 * 
 * @author Askur
 */
@Service("PapRencanaKonsultasiService")
public class PapRencanaKonsultasiServiceImpl implements PapRencanaKonsultasiService {
	@Autowired
	private PapRencanaKonsultasiDao papRencanaKonsultasiDao;
	@Autowired
	private PapRencanaKonsultasiConverter papRencanaKonsultasiConverter;
	@Autowired
	private PasienDaftarDao pasienDaftarDao;
	@Autowired
	private AntrianPasienDiPeriksaDao antrianPasienDiPeriksaDao;
	@Autowired
	private AntrianPasienDiPeriksaService antrianPasienDiPeriksaService;

	@Override
	public Map<String, Object> addRencanaKonsultasi(PapRencanaKonsultasiVO vo)
			throws JpaSystemException, ServiceVOException {
		Map<String, Object> result = new HashMap<String, Object>();

		PapRencanaKonsultasi model = papRencanaKonsultasiConverter.transferVOToModel(vo, new PapRencanaKonsultasi());
		model.setPasien(antrianPasienDiPeriksaDao.finByNoIdAndTglRegistrasi(Short.parseShort("0"), vo.getPasien().getId(),
				vo.getTglRegistrasi()));
		AntrianPasienDiPeriksa antrianPasienDiPeriksa = new AntrianPasienDiPeriksa();
		if (vo.getNoRec()==null) {
			antrianPasienDiPeriksa = new AntrianPasienDiPeriksa();
			antrianPasienDiPeriksa.setTglRegistrasi(new Date());
			antrianPasienDiPeriksa.setStatusPasien((byte) 1);
			antrianPasienDiPeriksa.setRuangan(model.getRuangan());
			antrianPasienDiPeriksa.setStatusAntrian(StatusAntrianEnum.MENUNGGU.getVal());

			if (antrianPasienDiPeriksaService.checkStatusPasien(vo.getRuangan().getId(), vo.getPasien().getId())) {
				antrianPasienDiPeriksa.setStatusKunjungan(StatusKunjunganEnum.LAMA.getVal());
			} else {
				antrianPasienDiPeriksa.setStatusKunjungan(StatusKunjunganEnum.BARU.getVal());
			}
			antrianPasienDiPeriksaService.saveAntrianPasienDiperiksaFromMasukKamar(model.getPasien().getPasienDaftar(),antrianPasienDiPeriksa);
		}
	

	PapRencanaKonsultasi resultModel=papRencanaKonsultasiDao.save(model);

	if(CommonUtil.isNotNullOrEmpty(resultModel))

	{
		result.put("noRec", resultModel.getNoRec());
		result.put("tglInput", resultModel.getTglInput());
		if (CommonUtil.isNotNullOrEmpty(resultModel.getPasien().getPasienDaftar().getPasien().getId())) {
			result.put("pasien.noCm", resultModel.getPasien().getPasienDaftar().getPasien().getNoCm());
		}
	} return result;

	}

	@Override
	public Map<String, Object> updateRencanaKonsultasi(PapRencanaKonsultasiVO vo) throws JpaSystemException, ServiceVOException {
		Map<String,Object> result=new HashMap<String,Object>();
		PapRencanaKonsultasi model=papRencanaKonsultasiDao.findOne(vo.getNoRec());
		PapRencanaKonsultasi resultModel=papRencanaKonsultasiDao.save(model);
		if(CommonUtil.isNotNullOrEmpty(resultModel)){
			result.put("noRec", resultModel.getNoRec());
			result.put("tglInput", resultModel.getTglInput());
			result.put("datafound", true);
			if(CommonUtil.isNotNullOrEmpty(resultModel.getPasien().getPasienDaftar().getPasien().getId())){
				result.put("pasien.noCm", resultModel.getPasien().getPasienDaftar().getPasien().getNoCm());
			}
		}else{
			result.put("datafound", false);
		}
		return result;
	}

	@Override
	public Map<String, Object> findByNoCmAndTglInput(String noCm, Date tglInput) {
		Map<String, Object> result = new HashMap<String, Object>();
		// PapRencanaKonsultasi resultModel=
		// if(CommonUtil.isNotNullOrEmpty(resultModel)){
		// result.put("noRec", resultModel.getNoRec());
		// result.put("tglInput", resultModel.getTglInput());
		// result.put("datafound", true);
		// if(CommonUtil.isNotNullOrEmpty(resultModel.getPasien().getPasien().getId())){
		// result.put("pasien.noCm",
		// resultModel.getPasien().getPasien().getNoCm());
		// }
		// }else{
		result.put("datafound", false);
		// }
		return result;
	}

	@Override
	public Object add(Object vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Object update(Object vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Boolean delete(Object key) throws JpaSystemException {
		return null;
	}

	@Override
	public Object findById(Object key) throws JpaSystemException {
		return null;
	}

	@Override
	public List findAll() throws JpaSystemException {
		return null;
	}

	@Override
	public Map findAllWithPageAndLimitAndSortByAndDirectionParameter(Integer page, Integer limit, String sort,
			String dir) {
		return null;
	}

}
